<template>
  <AggregateRowsDataSourceForm
    v-if="dataSource"
    ref="dataSourceForm"
    :dashboard="dashboard"
    :widget="widget"
    :data-source="dataSource"
    :default-values="dataSource"
    @values-changed="onDataSourceValuesChanged"
  />
</template>

<script>
import AggregateRowsDataSourceForm from '@baserow/modules/dashboard/components/data_source/AggregateRowsDataSourceForm'
import error from '@baserow/modules/core/mixins/error'
import { mapActions } from 'vuex'
import { notifyIf } from '@baserow/modules/core/utils/error'

export default {
  name: 'SummaryWidgetSettings',
  components: { AggregateRowsDataSourceForm },
  mixins: [error],
  props: {
    dashboard: {
      type: Object,
      required: true,
    },
    widget: {
      type: Object,
      required: true,
    },
  },
  data() {
    return {
      loading: false,
    }
  },
  computed: {
    dataSource() {
      return this.$store.getters['dashboardApplication/getDataSourceById'](
        this.widget.data_source_id
      )
    },
    integration() {
      return this.$store.getters['dashboardApplication/getIntegrationById'](
        this.dataSource.integration_id
      )
    },
  },
  methods: {
    ...mapActions({
      updateDataSource: 'dashboardApplication/updateDataSource',
    }),
    async onDataSourceValuesChanged(changedDataSourceValues) {
      if (this.$refs.dataSourceForm.isFormValid()) {
        try {
          await this.updateDataSource({
            dataSourceId: this.dataSource.id,
            values: changedDataSourceValues,
          })
        } catch (error) {
          this.$refs.dataSourceForm.reset()
          this.$refs.dataSourceForm.touch()
          notifyIf(error, 'dashboard')
        }
      }
    },
  },
}
</script>
